$AdfDhtmlMenuPeer$$.$_SUB_ID_MAP$ = {scroll_up_button:"ScrollUp", scroll_down_button:"ScrollDown", popup:"menu", close_button:"close", detach_handle:"handle", popup_scroll_box:"ScrollBox"};
$AdfDhtmlMenuPeer$$.prototype.$GetSubIdDomElement$ = function $$AdfDhtmlMenuPeer$$$$$GetSubIdDomElement$$($subElementId$$37$$) {
  var $component$$2441$$ = this.$getComponent$(), $childElement$$31_rootElement$$181$$ = $AdfSubIdUtils$$.$getSubIdDomElementByMappedSubId$($subElementId$$37$$, $AdfDhtmlMenuPeer$$.$_SUB_ID_MAP$, $component$$2441$$);
  if ($childElement$$31_rootElement$$181$$) {
    return $childElement$$31_rootElement$$181$$;
  }
  $childElement$$31_rootElement$$181$$ = this.$getDomElement$();
  return $AdfMenuSubIdUtils$$.$getMenuItemElement$($component$$2441$$, $childElement$$31_rootElement$$181$$, $subElementId$$37$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlMenuPeer.prototype.GetSubIdDomElement", {$GetSubIdDomElement$:$AdfDhtmlMenuPeer$$.prototype.$GetSubIdDomElement$});
$AdfDhtmlMenuPeer$$.prototype.$GetBestMatchSubId$ = function $$AdfDhtmlMenuPeer$$$$$GetBestMatchSubId$$($childElement$$32_clientSubId$$3$$) {
  var $component$$2442_subId$$53_subIdMap$$1$$ = this.$getComponent$(), $idx$$2_rootElement$$182$$ = this.$getDomElement$(), $component$$2442_subId$$53_subIdMap$$1$$ = $AdfMenuSubIdUtils$$.$getMenuItemBestMatchSubId$($component$$2442_subId$$53_subIdMap$$1$$, $idx$$2_rootElement$$182$$, $childElement$$32_clientSubId$$3$$);
  if (null != $component$$2442_subId$$53_subIdMap$$1$$) {
    return $component$$2442_subId$$53_subIdMap$$1$$;
  }
  $component$$2442_subId$$53_subIdMap$$1$$ = $AdfSubIdUtils$$.$getBestMatchSubId$($childElement$$32_clientSubId$$3$$, this, $AdfDhtmlMenuPeer$$.$_SUB_ID_MAP$);
  if (null != $component$$2442_subId$$53_subIdMap$$1$$) {
    return $component$$2442_subId$$53_subIdMap$$1$$;
  }
  if ($childElement$$32_clientSubId$$3$$ && $childElement$$32_clientSubId$$3$$.id && ($idx$$2_rootElement$$182$$ = $childElement$$32_clientSubId$$3$$.id.lastIndexOf("::"), 0 < $idx$$2_rootElement$$182$$ && $childElement$$32_clientSubId$$3$$.id.substr(0, $idx$$2_rootElement$$182$$) == this.$getComponent$().$getClientId$())) {
    $component$$2442_subId$$53_subIdMap$$1$$ = $AdfDhtmlMenuPeer$$.$_SUB_ID_MAP$;
    $childElement$$32_clientSubId$$3$$ = $childElement$$32_clientSubId$$3$$.id.substr($idx$$2_rootElement$$182$$ + 2);
    for (var $extSubId$$ in $component$$2442_subId$$53_subIdMap$$1$$) {
      if ($component$$2442_subId$$53_subIdMap$$1$$[$extSubId$$] == $childElement$$32_clientSubId$$3$$) {
        return $extSubId$$;
      }
    }
  }
  return null;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlMenuPeer.prototype.GetBestMatchSubId", {$GetBestMatchSubId$:$AdfDhtmlMenuPeer$$.prototype.$GetBestMatchSubId$});
